Require Import Omega.
(* Commment in COQ *)
(* Prove that this function is always even *)
(* using boolean values.  This is decidable, as opposed to the *)
(* the proposition.   Hence, its easier. *)
Lemma L0_92:forall n:nat, Nat.even(0*n+92)=true.
Proof.
intros. 
assert (HY0:Nat.even(0)=true).
{
	simpl.
	reflexivity.
}
assert (HY92:Nat.even(92)=true).
{
	simpl.
	reflexivity.
}
assert (HYE92:Nat.Even(92)).
{
	apply Nat.even_spec.
	rewrite HY92;auto.
}
assert (HYN: Nat.even(0*n)=true).
{
	 rewrite Nat.even_mul.
	 rewrite HY0.
	 simpl. 
	 reflexivity.
}
rewrite Nat.even_add_even.
rewrite HYN.
reflexivity.
apply  HYE92.
Qed.
(* Commment in COQ *)
(* Prove that this function is always even *)
(* in Propositional Form.  Use the Boolean Lemma above. *)
Theorem T0_92:forall n:nat, Nat.Even(0*n+92).
Proof.
intros. 
apply Nat.even_spec.
apply L0_92.
Qed.
