Require Import Omega.
(* Commment in COQ *)
(* Prove that this function is always even *)
(* using boolean values.  This is decidable, as opposed to the *)
(* the proposition.   Hence, its easier. *)
Lemma L12_10:forall n:nat, Nat.even(12*n+10)=true.
Proof.
intros. 
assert (HY12:Nat.even(12)=true).
{
	simpl.
	reflexivity.
}
assert (HY10:Nat.even(10)=true).
{
	simpl.
	reflexivity.
}
assert (HYE10:Nat.Even(10)).
{
	apply Nat.even_spec.
	rewrite HY10;auto.
}
assert (HYN: Nat.even(12*n)=true).
{
	 rewrite Nat.even_mul.
	 rewrite HY12.
	 simpl. 
	 reflexivity.
}
rewrite Nat.even_add_even.
rewrite HYN.
reflexivity.
apply  HYE10.
Qed.
(* Commment in COQ *)
(* Prove that this function is always even *)
(* in Propositional Form.  Use the Boolean Lemma above. *)
Theorem T12_10:forall n:nat, Nat.Even(12*n+10).
Proof.
intros. 
apply Nat.even_spec.
apply L12_10.
Qed.
