Require Import Omega.
(* Commment in COQ *)
(* Prove that this function is always even *)
(* using boolean values.  This is decidable, as opposed to the *)
(* the proposition.   Hence, its easier. *)
Lemma L16_74:forall n:nat, Nat.even(16*n+74)=true.
Proof.
intros. 
assert (HY16:Nat.even(16)=true).
{
	simpl.
	reflexivity.
}
assert (HY74:Nat.even(74)=true).
{
	simpl.
	reflexivity.
}
assert (HYE74:Nat.Even(74)).
{
	apply Nat.even_spec.
	rewrite HY74;auto.
}
assert (HYN: Nat.even(16*n)=true).
{
	 rewrite Nat.even_mul.
	 rewrite HY16.
	 simpl. 
	 reflexivity.
}
rewrite Nat.even_add_even.
rewrite HYN.
reflexivity.
apply  HYE74.
Qed.
(* Commment in COQ *)
(* Prove that this function is always even *)
(* in Propositional Form.  Use the Boolean Lemma above. *)
Theorem T16_74:forall n:nat, Nat.Even(16*n+74).
Proof.
intros. 
apply Nat.even_spec.
apply L16_74.
Qed.
