Require Import Omega.
(* Commment in COQ *)
(* Prove that this function is always even *)
(* using boolean values.  This is decidable, as opposed to the *)
(* the proposition.   Hence, its easier. *)
Lemma L16_90:forall n:nat, Nat.even(16*n+90)=true.
Proof.
intros. 
assert (HY16:Nat.even(16)=true).
{
	simpl.
	reflexivity.
}
assert (HY90:Nat.even(90)=true).
{
	simpl.
	reflexivity.
}
assert (HYE90:Nat.Even(90)).
{
	apply Nat.even_spec.
	rewrite HY90;auto.
}
assert (HYN: Nat.even(16*n)=true).
{
	 rewrite Nat.even_mul.
	 rewrite HY16.
	 simpl. 
	 reflexivity.
}
rewrite Nat.even_add_even.
rewrite HYN.
reflexivity.
apply  HYE90.
Qed.
(* Commment in COQ *)
(* Prove that this function is always even *)
(* in Propositional Form.  Use the Boolean Lemma above. *)
Theorem T16_90:forall n:nat, Nat.Even(16*n+90).
Proof.
intros. 
apply Nat.even_spec.
apply L16_90.
Qed.
