Require Import Omega.
(* Commment in COQ *)
(* Prove that this function is always even *)
(* using boolean values.  This is decidable, as opposed to the *)
(* the proposition.   Hence, its easier. *)
Lemma L44_22:forall n:nat, Nat.even(44*n+22)=true.
Proof.
intros. 
assert (HY44:Nat.even(44)=true).
{
	simpl.
	reflexivity.
}
assert (HY22:Nat.even(22)=true).
{
	simpl.
	reflexivity.
}
assert (HYE22:Nat.Even(22)).
{
	apply Nat.even_spec.
	rewrite HY22;auto.
}
assert (HYN: Nat.even(44*n)=true).
{
	 rewrite Nat.even_mul.
	 rewrite HY44.
	 simpl. 
	 reflexivity.
}
rewrite Nat.even_add_even.
rewrite HYN.
reflexivity.
apply  HYE22.
Qed.
(* Commment in COQ *)
(* Prove that this function is always even *)
(* in Propositional Form.  Use the Boolean Lemma above. *)
Theorem T44_22:forall n:nat, Nat.Even(44*n+22).
Proof.
intros. 
apply Nat.even_spec.
apply L44_22.
Qed.
