Require Import Omega.
(* Commment in COQ *)
(* Prove that this function is always even *)
(* using boolean values.  This is decidable, as opposed to the *)
(* the proposition.   Hence, its easier. *)
Lemma L58_24:forall n:nat, Nat.even(58*n+24)=true.
Proof.
intros. 
assert (HY58:Nat.even(58)=true).
{
	simpl.
	reflexivity.
}
assert (HY24:Nat.even(24)=true).
{
	simpl.
	reflexivity.
}
assert (HYE24:Nat.Even(24)).
{
	apply Nat.even_spec.
	rewrite HY24;auto.
}
assert (HYN: Nat.even(58*n)=true).
{
	 rewrite Nat.even_mul.
	 rewrite HY58.
	 simpl. 
	 reflexivity.
}
rewrite Nat.even_add_even.
rewrite HYN.
reflexivity.
apply  HYE24.
Qed.
(* Commment in COQ *)
(* Prove that this function is always even *)
(* in Propositional Form.  Use the Boolean Lemma above. *)
Theorem T58_24:forall n:nat, Nat.Even(58*n+24).
Proof.
intros. 
apply Nat.even_spec.
apply L58_24.
Qed.
