Require Import Omega.
(* Commment in COQ *)
(* Prove that this function is always even *)
(* using boolean values.  This is decidable, as opposed to the *)
(* the proposition.   Hence, its easier. *)
Lemma L6_2:forall n:nat, Nat.even(6*n+2)=true.
Proof.
intros. 
assert (HY6:Nat.even(6)=true).
{
	simpl.
	reflexivity.
}
assert (HY2:Nat.even(2)=true).
{
	simpl.
	reflexivity.
}
assert (HYE2:Nat.Even(2)).
{
	apply Nat.even_spec.
	rewrite HY2;auto.
}
assert (HYN: Nat.even(6*n)=true).
{
	 rewrite Nat.even_mul.
	 rewrite HY6.
	 simpl. 
	 reflexivity.
}
rewrite Nat.even_add_even.
rewrite HYN.
reflexivity.
apply  HYE2.
Qed.
(* Commment in COQ *)
(* Prove that this function is always even *)
(* in Propositional Form.  Use the Boolean Lemma above. *)
Theorem T6_2:forall n:nat, Nat.Even(6*n+2).
Proof.
intros. 
apply Nat.even_spec.
apply L6_2.
Qed.
