Require Import Omega.
(* Commment in COQ *)
(* Prove that this function is always even *)
(* using boolean values.  This is decidable, as opposed to the *)
(* the proposition.   Hence, its easier. *)
Lemma L6_20:forall n:nat, Nat.even(6*n+20)=true.
Proof.
intros. 
assert (HY6:Nat.even(6)=true).
{
	simpl.
	reflexivity.
}
assert (HY20:Nat.even(20)=true).
{
	simpl.
	reflexivity.
}
assert (HYE20:Nat.Even(20)).
{
	apply Nat.even_spec.
	rewrite HY20;auto.
}
assert (HYN: Nat.even(6*n)=true).
{
	 rewrite Nat.even_mul.
	 rewrite HY6.
	 simpl. 
	 reflexivity.
}
rewrite Nat.even_add_even.
rewrite HYN.
reflexivity.
apply  HYE20.
Qed.
(* Commment in COQ *)
(* Prove that this function is always even *)
(* in Propositional Form.  Use the Boolean Lemma above. *)
Theorem T6_20:forall n:nat, Nat.Even(6*n+20).
Proof.
intros. 
apply Nat.even_spec.
apply L6_20.
Qed.
