Require Import Omega.
(* Commment in COQ *)
(* Prove that this function is always even *)
(* using boolean values.  This is decidable, as opposed to the *)
(* the proposition.   Hence, its easier. *)
Lemma L74_36:forall n:nat, Nat.even(74*n+36)=true.
Proof.
intros. 
assert (HY74:Nat.even(74)=true).
{
	simpl.
	reflexivity.
}
assert (HY36:Nat.even(36)=true).
{
	simpl.
	reflexivity.
}
assert (HYE36:Nat.Even(36)).
{
	apply Nat.even_spec.
	rewrite HY36;auto.
}
assert (HYN: Nat.even(74*n)=true).
{
	 rewrite Nat.even_mul.
	 rewrite HY74.
	 simpl. 
	 reflexivity.
}
rewrite Nat.even_add_even.
rewrite HYN.
reflexivity.
apply  HYE36.
Qed.
(* Commment in COQ *)
(* Prove that this function is always even *)
(* in Propositional Form.  Use the Boolean Lemma above. *)
Theorem T74_36:forall n:nat, Nat.Even(74*n+36).
Proof.
intros. 
apply Nat.even_spec.
apply L74_36.
Qed.
