Require Import Omega.
(* Commment in COQ *)
(* Prove that this function is always even *)
(* using boolean values.  This is decidable, as opposed to the *)
(* the proposition.   Hence, its easier. *)
Lemma L88_12:forall n:nat, Nat.even(88*n+12)=true.
Proof.
intros. 
assert (HY88:Nat.even(88)=true).
{
	simpl.
	reflexivity.
}
assert (HY12:Nat.even(12)=true).
{
	simpl.
	reflexivity.
}
assert (HYE12:Nat.Even(12)).
{
	apply Nat.even_spec.
	rewrite HY12;auto.
}
assert (HYN: Nat.even(88*n)=true).
{
	 rewrite Nat.even_mul.
	 rewrite HY88.
	 simpl. 
	 reflexivity.
}
rewrite Nat.even_add_even.
rewrite HYN.
reflexivity.
apply  HYE12.
Qed.
(* Commment in COQ *)
(* Prove that this function is always even *)
(* in Propositional Form.  Use the Boolean Lemma above. *)
Theorem T88_12:forall n:nat, Nat.Even(88*n+12).
Proof.
intros. 
apply Nat.even_spec.
apply L88_12.
Qed.
