Require Import Omega.
(* Commment in COQ *)
(* Prove that this function is always odd *)
(* using boolean values.  This is decidable, as opposed to the *)
(* the proposition.   Hence, its easier. *)
Lemma L12_79:forall n:nat, Nat.odd(12*n+79)=true.
Proof.
intros. 
assert (HY12:Nat.even(12)=true).
{
	simpl.
	reflexivity.
}
assert (HY79:Nat.odd(79)=true).
{
	 unfold Nat.odd.
	simpl.
	reflexivity.
}
assert (HYN: Nat.even(12*n)=true).
{
	 rewrite Nat.even_mul.
	 rewrite HY12.
	 simpl. 
	 reflexivity.
}
assert (HYE12:Nat.Even(12*n)).
{
	apply Nat.even_spec.
	rewrite HYN;auto.
}
assert (HR:79+12*n = 12*n+ 79).
{
	 omega. 
}
rewrite <-HR.
rewrite Nat.odd_add_even.
rewrite HY79.
reflexivity.
apply HYE12.
Qed.
(* Commment in COQ *)
(* Prove that this function is always odd *)
(* in Propositional Form.  Use the Boolean Lemma above. *)
Theorem T12_79:forall n:nat, Nat.Odd(12*n+79).
Proof.
intros. 
apply Nat.odd_spec.
apply L12_79.
Qed.
