Require Import Omega.
(* Commment in COQ *)
(* Prove that this function is always odd *)
(* using boolean values.  This is decidable, as opposed to the *)
(* the proposition.   Hence, its easier. *)
Lemma L16_39:forall n:nat, Nat.odd(16*n+39)=true.
Proof.
intros. 
assert (HY16:Nat.even(16)=true).
{
	simpl.
	reflexivity.
}
assert (HY39:Nat.odd(39)=true).
{
	 unfold Nat.odd.
	simpl.
	reflexivity.
}
assert (HYN: Nat.even(16*n)=true).
{
	 rewrite Nat.even_mul.
	 rewrite HY16.
	 simpl. 
	 reflexivity.
}
assert (HYE16:Nat.Even(16*n)).
{
	apply Nat.even_spec.
	rewrite HYN;auto.
}
assert (HR:39+16*n = 16*n+ 39).
{
	 omega. 
}
rewrite <-HR.
rewrite Nat.odd_add_even.
rewrite HY39.
reflexivity.
apply HYE16.
Qed.
(* Commment in COQ *)
(* Prove that this function is always odd *)
(* in Propositional Form.  Use the Boolean Lemma above. *)
Theorem T16_39:forall n:nat, Nat.Odd(16*n+39).
Proof.
intros. 
apply Nat.odd_spec.
apply L16_39.
Qed.
