Require Import Omega.
(* Commment in COQ *)
(* Prove that this function is always odd *)
(* using boolean values.  This is decidable, as opposed to the *)
(* the proposition.   Hence, its easier. *)
Lemma L18_27:forall n:nat, Nat.odd(18*n+27)=true.
Proof.
intros. 
assert (HY18:Nat.even(18)=true).
{
	simpl.
	reflexivity.
}
assert (HY27:Nat.odd(27)=true).
{
	 unfold Nat.odd.
	simpl.
	reflexivity.
}
assert (HYN: Nat.even(18*n)=true).
{
	 rewrite Nat.even_mul.
	 rewrite HY18.
	 simpl. 
	 reflexivity.
}
assert (HYE18:Nat.Even(18*n)).
{
	apply Nat.even_spec.
	rewrite HYN;auto.
}
assert (HR:27+18*n = 18*n+ 27).
{
	 omega. 
}
rewrite <-HR.
rewrite Nat.odd_add_even.
rewrite HY27.
reflexivity.
apply HYE18.
Qed.
(* Commment in COQ *)
(* Prove that this function is always odd *)
(* in Propositional Form.  Use the Boolean Lemma above. *)
Theorem T18_27:forall n:nat, Nat.Odd(18*n+27).
Proof.
intros. 
apply Nat.odd_spec.
apply L18_27.
Qed.
