Require Import Omega.
(* Commment in COQ *)
(* Prove that this function is always odd *)
(* using boolean values.  This is decidable, as opposed to the *)
(* the proposition.   Hence, its easier. *)
Lemma L26_53:forall n:nat, Nat.odd(26*n+53)=true.
Proof.
intros. 
assert (HY26:Nat.even(26)=true).
{
	simpl.
	reflexivity.
}
assert (HY53:Nat.odd(53)=true).
{
	 unfold Nat.odd.
	simpl.
	reflexivity.
}
assert (HYN: Nat.even(26*n)=true).
{
	 rewrite Nat.even_mul.
	 rewrite HY26.
	 simpl. 
	 reflexivity.
}
assert (HYE26:Nat.Even(26*n)).
{
	apply Nat.even_spec.
	rewrite HYN;auto.
}
assert (HR:53+26*n = 26*n+ 53).
{
	 omega. 
}
rewrite <-HR.
rewrite Nat.odd_add_even.
rewrite HY53.
reflexivity.
apply HYE26.
Qed.
(* Commment in COQ *)
(* Prove that this function is always odd *)
(* in Propositional Form.  Use the Boolean Lemma above. *)
Theorem T26_53:forall n:nat, Nat.Odd(26*n+53).
Proof.
intros. 
apply Nat.odd_spec.
apply L26_53.
Qed.
