Require Import Omega.
(* Commment in COQ *)
(* Prove that this function is always odd *)
(* using boolean values.  This is decidable, as opposed to the *)
(* the proposition.   Hence, its easier. *)
Lemma L28_35:forall n:nat, Nat.odd(28*n+35)=true.
Proof.
intros. 
assert (HY28:Nat.even(28)=true).
{
	simpl.
	reflexivity.
}
assert (HY35:Nat.odd(35)=true).
{
	 unfold Nat.odd.
	simpl.
	reflexivity.
}
assert (HYN: Nat.even(28*n)=true).
{
	 rewrite Nat.even_mul.
	 rewrite HY28.
	 simpl. 
	 reflexivity.
}
assert (HYE28:Nat.Even(28*n)).
{
	apply Nat.even_spec.
	rewrite HYN;auto.
}
assert (HR:35+28*n = 28*n+ 35).
{
	 omega. 
}
rewrite <-HR.
rewrite Nat.odd_add_even.
rewrite HY35.
reflexivity.
apply HYE28.
Qed.
(* Commment in COQ *)
(* Prove that this function is always odd *)
(* in Propositional Form.  Use the Boolean Lemma above. *)
Theorem T28_35:forall n:nat, Nat.Odd(28*n+35).
Proof.
intros. 
apply Nat.odd_spec.
apply L28_35.
Qed.
