Require Import Omega.
(* Commment in COQ *)
(* Prove that this function is always odd *)
(* using boolean values.  This is decidable, as opposed to the *)
(* the proposition.   Hence, its easier. *)
Lemma L30_99:forall n:nat, Nat.odd(30*n+99)=true.
Proof.
intros. 
assert (HY30:Nat.even(30)=true).
{
	simpl.
	reflexivity.
}
assert (HY99:Nat.odd(99)=true).
{
	 unfold Nat.odd.
	simpl.
	reflexivity.
}
assert (HYN: Nat.even(30*n)=true).
{
	 rewrite Nat.even_mul.
	 rewrite HY30.
	 simpl. 
	 reflexivity.
}
assert (HYE30:Nat.Even(30*n)).
{
	apply Nat.even_spec.
	rewrite HYN;auto.
}
assert (HR:99+30*n = 30*n+ 99).
{
	 omega. 
}
rewrite <-HR.
rewrite Nat.odd_add_even.
rewrite HY99.
reflexivity.
apply HYE30.
Qed.
(* Commment in COQ *)
(* Prove that this function is always odd *)
(* in Propositional Form.  Use the Boolean Lemma above. *)
Theorem T30_99:forall n:nat, Nat.Odd(30*n+99).
Proof.
intros. 
apply Nat.odd_spec.
apply L30_99.
Qed.
