Require Import Omega.
(* Commment in COQ *)
(* Prove that this function is always odd *)
(* using boolean values.  This is decidable, as opposed to the *)
(* the proposition.   Hence, its easier. *)
Lemma L36_51:forall n:nat, Nat.odd(36*n+51)=true.
Proof.
intros. 
assert (HY36:Nat.even(36)=true).
{
	simpl.
	reflexivity.
}
assert (HY51:Nat.odd(51)=true).
{
	 unfold Nat.odd.
	simpl.
	reflexivity.
}
assert (HYN: Nat.even(36*n)=true).
{
	 rewrite Nat.even_mul.
	 rewrite HY36.
	 simpl. 
	 reflexivity.
}
assert (HYE36:Nat.Even(36*n)).
{
	apply Nat.even_spec.
	rewrite HYN;auto.
}
assert (HR:51+36*n = 36*n+ 51).
{
	 omega. 
}
rewrite <-HR.
rewrite Nat.odd_add_even.
rewrite HY51.
reflexivity.
apply HYE36.
Qed.
(* Commment in COQ *)
(* Prove that this function is always odd *)
(* in Propositional Form.  Use the Boolean Lemma above. *)
Theorem T36_51:forall n:nat, Nat.Odd(36*n+51).
Proof.
intros. 
apply Nat.odd_spec.
apply L36_51.
Qed.
