Require Import Omega.
(* Commment in COQ *)
(* Prove that this function is always odd *)
(* using boolean values.  This is decidable, as opposed to the *)
(* the proposition.   Hence, its easier. *)
Lemma L40_89:forall n:nat, Nat.odd(40*n+89)=true.
Proof.
intros. 
assert (HY40:Nat.even(40)=true).
{
	simpl.
	reflexivity.
}
assert (HY89:Nat.odd(89)=true).
{
	 unfold Nat.odd.
	simpl.
	reflexivity.
}
assert (HYN: Nat.even(40*n)=true).
{
	 rewrite Nat.even_mul.
	 rewrite HY40.
	 simpl. 
	 reflexivity.
}
assert (HYE40:Nat.Even(40*n)).
{
	apply Nat.even_spec.
	rewrite HYN;auto.
}
assert (HR:89+40*n = 40*n+ 89).
{
	 omega. 
}
rewrite <-HR.
rewrite Nat.odd_add_even.
rewrite HY89.
reflexivity.
apply HYE40.
Qed.
(* Commment in COQ *)
(* Prove that this function is always odd *)
(* in Propositional Form.  Use the Boolean Lemma above. *)
Theorem T40_89:forall n:nat, Nat.Odd(40*n+89).
Proof.
intros. 
apply Nat.odd_spec.
apply L40_89.
Qed.
