Require Import Omega.
(* Commment in COQ *)
(* Prove that this function is always odd *)
(* using boolean values.  This is decidable, as opposed to the *)
(* the proposition.   Hence, its easier. *)
Lemma L48_21:forall n:nat, Nat.odd(48*n+21)=true.
Proof.
intros. 
assert (HY48:Nat.even(48)=true).
{
	simpl.
	reflexivity.
}
assert (HY21:Nat.odd(21)=true).
{
	 unfold Nat.odd.
	simpl.
	reflexivity.
}
assert (HYN: Nat.even(48*n)=true).
{
	 rewrite Nat.even_mul.
	 rewrite HY48.
	 simpl. 
	 reflexivity.
}
assert (HYE48:Nat.Even(48*n)).
{
	apply Nat.even_spec.
	rewrite HYN;auto.
}
assert (HR:21+48*n = 48*n+ 21).
{
	 omega. 
}
rewrite <-HR.
rewrite Nat.odd_add_even.
rewrite HY21.
reflexivity.
apply HYE48.
Qed.
(* Commment in COQ *)
(* Prove that this function is always odd *)
(* in Propositional Form.  Use the Boolean Lemma above. *)
Theorem T48_21:forall n:nat, Nat.Odd(48*n+21).
Proof.
intros. 
apply Nat.odd_spec.
apply L48_21.
Qed.
