Require Import Omega.
(* Commment in COQ *)
(* Prove that this function is always odd *)
(* using boolean values.  This is decidable, as opposed to the *)
(* the proposition.   Hence, its easier. *)
Lemma L68_9:forall n:nat, Nat.odd(68*n+9)=true.
Proof.
intros. 
assert (HY68:Nat.even(68)=true).
{
	simpl.
	reflexivity.
}
assert (HY9:Nat.odd(9)=true).
{
	 unfold Nat.odd.
	simpl.
	reflexivity.
}
assert (HYN: Nat.even(68*n)=true).
{
	 rewrite Nat.even_mul.
	 rewrite HY68.
	 simpl. 
	 reflexivity.
}
assert (HYE68:Nat.Even(68*n)).
{
	apply Nat.even_spec.
	rewrite HYN;auto.
}
assert (HR:9+68*n = 68*n+ 9).
{
	 omega. 
}
rewrite <-HR.
rewrite Nat.odd_add_even.
rewrite HY9.
reflexivity.
apply HYE68.
Qed.
(* Commment in COQ *)
(* Prove that this function is always odd *)
(* in Propositional Form.  Use the Boolean Lemma above. *)
Theorem T68_9:forall n:nat, Nat.Odd(68*n+9).
Proof.
intros. 
apply Nat.odd_spec.
apply L68_9.
Qed.
