Require Import Omega.
(* Commment in COQ *)
(* Prove that this function is always odd *)
(* using boolean values.  This is decidable, as opposed to the *)
(* the proposition.   Hence, its easier. *)
Lemma L82_33:forall n:nat, Nat.odd(82*n+33)=true.
Proof.
intros. 
assert (HY82:Nat.even(82)=true).
{
	simpl.
	reflexivity.
}
assert (HY33:Nat.odd(33)=true).
{
	 unfold Nat.odd.
	simpl.
	reflexivity.
}
assert (HYN: Nat.even(82*n)=true).
{
	 rewrite Nat.even_mul.
	 rewrite HY82.
	 simpl. 
	 reflexivity.
}
assert (HYE82:Nat.Even(82*n)).
{
	apply Nat.even_spec.
	rewrite HYN;auto.
}
assert (HR:33+82*n = 82*n+ 33).
{
	 omega. 
}
rewrite <-HR.
rewrite Nat.odd_add_even.
rewrite HY33.
reflexivity.
apply HYE82.
Qed.
(* Commment in COQ *)
(* Prove that this function is always odd *)
(* in Propositional Form.  Use the Boolean Lemma above. *)
Theorem T82_33:forall n:nat, Nat.Odd(82*n+33).
Proof.
intros. 
apply Nat.odd_spec.
apply L82_33.
Qed.
