Require Import Omega.
(* Commment in COQ *)
(* Prove that this function is always odd *)
(* using boolean values.  This is decidable, as opposed to the *)
(* the proposition.   Hence, its easier. *)
Lemma L90_85:forall n:nat, Nat.odd(90*n+85)=true.
Proof.
intros. 
assert (HY90:Nat.even(90)=true).
{
	simpl.
	reflexivity.
}
assert (HY85:Nat.odd(85)=true).
{
	 unfold Nat.odd.
	simpl.
	reflexivity.
}
assert (HYN: Nat.even(90*n)=true).
{
	 rewrite Nat.even_mul.
	 rewrite HY90.
	 simpl. 
	 reflexivity.
}
assert (HYE90:Nat.Even(90*n)).
{
	apply Nat.even_spec.
	rewrite HYN;auto.
}
assert (HR:85+90*n = 90*n+ 85).
{
	 omega. 
}
rewrite <-HR.
rewrite Nat.odd_add_even.
rewrite HY85.
reflexivity.
apply HYE90.
Qed.
(* Commment in COQ *)
(* Prove that this function is always odd *)
(* in Propositional Form.  Use the Boolean Lemma above. *)
Theorem T90_85:forall n:nat, Nat.Odd(90*n+85).
Proof.
intros. 
apply Nat.odd_spec.
apply L90_85.
Qed.
