Require Import Omega.
(* Commment in COQ *)
(* Prove that this function is always even *)
(* using boolean values.  This is decidable, as opposed to the *)
(* the proposition.   Hence, its easier. *)
Lemma L14_60:forall n:nat, Nat.even(14*n+60)=true.
Proof.
intros. 
assert (HY14:Nat.even(14)=true).
{
	simpl.
	reflexivity.
}
assert (HY60:Nat.even(60)=true).
{
	simpl.
	reflexivity.
}
assert (HYE60:Nat.Even(60)).
{
	apply Nat.even_spec.
	rewrite HY60;auto.
}
assert (HYN: Nat.even(14*n)=true).
{
	 rewrite Nat.even_mul.
	 rewrite HY14.
	 simpl. 
	 reflexivity.
}
rewrite Nat.even_add_even.
rewrite HYN.
reflexivity.
apply  HYE60.
Qed.
(* Commment in COQ *)
(* Prove that this function is always even *)
(* in Propositional Form.  Use the Boolean Lemma above. *)
Theorem T14_60:forall n:nat, Nat.Even(14*n+60).
Proof.
intros. 
apply Nat.even_spec.
apply L14_60.
Qed.
