Require Import Omega.
(* Commment in COQ *)
(* Prove that this function is always even *)
(* using boolean values.  This is decidable, as opposed to the *)
(* the proposition.   Hence, its easier. *)
Lemma L52_8:forall n:nat, Nat.even(52*n+8)=true.
Proof.
intros. 
assert (HY52:Nat.even(52)=true).
{
	simpl.
	reflexivity.
}
assert (HY8:Nat.even(8)=true).
{
	simpl.
	reflexivity.
}
assert (HYE8:Nat.Even(8)).
{
	apply Nat.even_spec.
	rewrite HY8;auto.
}
assert (HYN: Nat.even(52*n)=true).
{
	 rewrite Nat.even_mul.
	 rewrite HY52.
	 simpl. 
	 reflexivity.
}
rewrite Nat.even_add_even.
rewrite HYN.
reflexivity.
apply  HYE8.
Qed.
(* Commment in COQ *)
(* Prove that this function is always even *)
(* in Propositional Form.  Use the Boolean Lemma above. *)
Theorem T52_8:forall n:nat, Nat.Even(52*n+8).
Proof.
intros. 
apply Nat.even_spec.
apply L52_8.
Qed.
