Require Import Omega.
(* Commment in COQ *)
(* Prove that this function is always even *)
(* using boolean values.  This is decidable, as opposed to the *)
(* the proposition.   Hence, its easier. *)
Lemma L68_38:forall n:nat, Nat.even(68*n+38)=true.
Proof.
intros. 
assert (HY68:Nat.even(68)=true).
{
	simpl.
	reflexivity.
}
assert (HY38:Nat.even(38)=true).
{
	simpl.
	reflexivity.
}
assert (HYE38:Nat.Even(38)).
{
	apply Nat.even_spec.
	rewrite HY38;auto.
}
assert (HYN: Nat.even(68*n)=true).
{
	 rewrite Nat.even_mul.
	 rewrite HY68.
	 simpl. 
	 reflexivity.
}
rewrite Nat.even_add_even.
rewrite HYN.
reflexivity.
apply  HYE38.
Qed.
(* Commment in COQ *)
(* Prove that this function is always even *)
(* in Propositional Form.  Use the Boolean Lemma above. *)
Theorem T68_38:forall n:nat, Nat.Even(68*n+38).
Proof.
intros. 
apply Nat.even_spec.
apply L68_38.
Qed.
