Require Import Omega.
(* Commment in COQ *)
(* Prove that this function is always even *)
(* using boolean values.  This is decidable, as opposed to the *)
(* the proposition.   Hence, its easier. *)
Lemma L6_94:forall n:nat, Nat.even(6*n+94)=true.
Proof.
intros. 
assert (HY6:Nat.even(6)=true).
{
	simpl.
	reflexivity.
}
assert (HY94:Nat.even(94)=true).
{
	simpl.
	reflexivity.
}
assert (HYE94:Nat.Even(94)).
{
	apply Nat.even_spec.
	rewrite HY94;auto.
}
assert (HYN: Nat.even(6*n)=true).
{
	 rewrite Nat.even_mul.
	 rewrite HY6.
	 simpl. 
	 reflexivity.
}
rewrite Nat.even_add_even.
rewrite HYN.
reflexivity.
apply  HYE94.
Qed.
(* Commment in COQ *)
(* Prove that this function is always even *)
(* in Propositional Form.  Use the Boolean Lemma above. *)
Theorem T6_94:forall n:nat, Nat.Even(6*n+94).
Proof.
intros. 
apply Nat.even_spec.
apply L6_94.
Qed.
