Require Import Omega.
(* Commment in COQ *)
(* Prove that this function is always even *)
(* using boolean values.  This is decidable, as opposed to the *)
(* the proposition.   Hence, its easier. *)
Lemma L78_30:forall n:nat, Nat.even(78*n+30)=true.
Proof.
intros. 
assert (HY78:Nat.even(78)=true).
{
	simpl.
	reflexivity.
}
assert (HY30:Nat.even(30)=true).
{
	simpl.
	reflexivity.
}
assert (HYE30:Nat.Even(30)).
{
	apply Nat.even_spec.
	rewrite HY30;auto.
}
assert (HYN: Nat.even(78*n)=true).
{
	 rewrite Nat.even_mul.
	 rewrite HY78.
	 simpl. 
	 reflexivity.
}
rewrite Nat.even_add_even.
rewrite HYN.
reflexivity.
apply  HYE30.
Qed.
(* Commment in COQ *)
(* Prove that this function is always even *)
(* in Propositional Form.  Use the Boolean Lemma above. *)
Theorem T78_30:forall n:nat, Nat.Even(78*n+30).
Proof.
intros. 
apply Nat.even_spec.
apply L78_30.
Qed.
