Require Import Omega.
(* Commment in COQ *)
(* Prove that this function is always odd *)
(* using boolean values.  This is decidable, as opposed to the *)
(* the proposition.   Hence, its easier. *)
Lemma L22_89:forall n:nat, Nat.odd(22*n+89)=true.
Proof.
intros. 
assert (HY22:Nat.even(22)=true).
{
	simpl.
	reflexivity.
}
assert (HY89:Nat.odd(89)=true).
{
	 unfold Nat.odd.
	simpl.
	reflexivity.
}
assert (HYN: Nat.even(22*n)=true).
{
	 rewrite Nat.even_mul.
	 rewrite HY22.
	 simpl. 
	 reflexivity.
}
assert (HYE22:Nat.Even(22*n)).
{
	apply Nat.even_spec.
	rewrite HYN;auto.
}
assert (HR:89+22*n = 22*n+ 89).
{
	 omega. 
}
rewrite <-HR.
rewrite Nat.odd_add_even.
rewrite HY89.
reflexivity.
apply HYE22.
Qed.
(* Commment in COQ *)
(* Prove that this function is always odd *)
(* in Propositional Form.  Use the Boolean Lemma above. *)
Theorem T22_89:forall n:nat, Nat.Odd(22*n+89).
Proof.
intros. 
apply Nat.odd_spec.
apply L22_89.
Qed.
