Require Import Omega.
(* Commment in COQ *)
(* Prove that this function is always odd *)
(* using boolean values.  This is decidable, as opposed to the *)
(* the proposition.   Hence, its easier. *)
Lemma L46_81:forall n:nat, Nat.odd(46*n+81)=true.
Proof.
intros. 
assert (HY46:Nat.even(46)=true).
{
	simpl.
	reflexivity.
}
assert (HY81:Nat.odd(81)=true).
{
	 unfold Nat.odd.
	simpl.
	reflexivity.
}
assert (HYN: Nat.even(46*n)=true).
{
	 rewrite Nat.even_mul.
	 rewrite HY46.
	 simpl. 
	 reflexivity.
}
assert (HYE46:Nat.Even(46*n)).
{
	apply Nat.even_spec.
	rewrite HYN;auto.
}
assert (HR:81+46*n = 46*n+ 81).
{
	 omega. 
}
rewrite <-HR.
rewrite Nat.odd_add_even.
rewrite HY81.
reflexivity.
apply HYE46.
Qed.
(* Commment in COQ *)
(* Prove that this function is always odd *)
(* in Propositional Form.  Use the Boolean Lemma above. *)
Theorem T46_81:forall n:nat, Nat.Odd(46*n+81).
Proof.
intros. 
apply Nat.odd_spec.
apply L46_81.
Qed.
