Require Import Omega.
(* Commment in COQ *)
(* Prove that this function is always odd *)
(* using boolean values.  This is decidable, as opposed to the *)
(* the proposition.   Hence, its easier. *)
Lemma L52_7:forall n:nat, Nat.odd(52*n+7)=true.
Proof.
intros. 
assert (HY52:Nat.even(52)=true).
{
	simpl.
	reflexivity.
}
assert (HY7:Nat.odd(7)=true).
{
	 unfold Nat.odd.
	simpl.
	reflexivity.
}
assert (HYN: Nat.even(52*n)=true).
{
	 rewrite Nat.even_mul.
	 rewrite HY52.
	 simpl. 
	 reflexivity.
}
assert (HYE52:Nat.Even(52*n)).
{
	apply Nat.even_spec.
	rewrite HYN;auto.
}
assert (HR:7+52*n = 52*n+ 7).
{
	 omega. 
}
rewrite <-HR.
rewrite Nat.odd_add_even.
rewrite HY7.
reflexivity.
apply HYE52.
Qed.
(* Commment in COQ *)
(* Prove that this function is always odd *)
(* in Propositional Form.  Use the Boolean Lemma above. *)
Theorem T52_7:forall n:nat, Nat.Odd(52*n+7).
Proof.
intros. 
apply Nat.odd_spec.
apply L52_7.
Qed.
