Require Import Omega.
(* Commment in COQ *)
(* Prove that this function is always odd *)
(* using boolean values.  This is decidable, as opposed to the *)
(* the proposition.   Hence, its easier. *)
Lemma L64_43:forall n:nat, Nat.odd(64*n+43)=true.
Proof.
intros. 
assert (HY64:Nat.even(64)=true).
{
	simpl.
	reflexivity.
}
assert (HY43:Nat.odd(43)=true).
{
	 unfold Nat.odd.
	simpl.
	reflexivity.
}
assert (HYN: Nat.even(64*n)=true).
{
	 rewrite Nat.even_mul.
	 rewrite HY64.
	 simpl. 
	 reflexivity.
}
assert (HYE64:Nat.Even(64*n)).
{
	apply Nat.even_spec.
	rewrite HYN;auto.
}
assert (HR:43+64*n = 64*n+ 43).
{
	 omega. 
}
rewrite <-HR.
rewrite Nat.odd_add_even.
rewrite HY43.
reflexivity.
apply HYE64.
Qed.
(* Commment in COQ *)
(* Prove that this function is always odd *)
(* in Propositional Form.  Use the Boolean Lemma above. *)
Theorem T64_43:forall n:nat, Nat.Odd(64*n+43).
Proof.
intros. 
apply Nat.odd_spec.
apply L64_43.
Qed.
