Require Import Omega.
(* Commment in COQ *)
(* Prove that this function is always odd *)
(* using boolean values.  This is decidable, as opposed to the *)
(* the proposition.   Hence, its easier. *)
Lemma L78_79:forall n:nat, Nat.odd(78*n+79)=true.
Proof.
intros. 
assert (HY78:Nat.even(78)=true).
{
	simpl.
	reflexivity.
}
assert (HY79:Nat.odd(79)=true).
{
	 unfold Nat.odd.
	simpl.
	reflexivity.
}
assert (HYN: Nat.even(78*n)=true).
{
	 rewrite Nat.even_mul.
	 rewrite HY78.
	 simpl. 
	 reflexivity.
}
assert (HYE78:Nat.Even(78*n)).
{
	apply Nat.even_spec.
	rewrite HYN;auto.
}
assert (HR:79+78*n = 78*n+ 79).
{
	 omega. 
}
rewrite <-HR.
rewrite Nat.odd_add_even.
rewrite HY79.
reflexivity.
apply HYE78.
Qed.
(* Commment in COQ *)
(* Prove that this function is always odd *)
(* in Propositional Form.  Use the Boolean Lemma above. *)
Theorem T78_79:forall n:nat, Nat.Odd(78*n+79).
Proof.
intros. 
apply Nat.odd_spec.
apply L78_79.
Qed.
