Require Import Omega.
(* Commment in COQ *)
(* Prove that this function is always odd *)
(* using boolean values.  This is decidable, as opposed to the *)
(* the proposition.   Hence, its easier. *)
Lemma L80_91:forall n:nat, Nat.odd(80*n+91)=true.
Proof.
intros. 
assert (HY80:Nat.even(80)=true).
{
	simpl.
	reflexivity.
}
assert (HY91:Nat.odd(91)=true).
{
	 unfold Nat.odd.
	simpl.
	reflexivity.
}
assert (HYN: Nat.even(80*n)=true).
{
	 rewrite Nat.even_mul.
	 rewrite HY80.
	 simpl. 
	 reflexivity.
}
assert (HYE80:Nat.Even(80*n)).
{
	apply Nat.even_spec.
	rewrite HYN;auto.
}
assert (HR:91+80*n = 80*n+ 91).
{
	 omega. 
}
rewrite <-HR.
rewrite Nat.odd_add_even.
rewrite HY91.
reflexivity.
apply HYE80.
Qed.
(* Commment in COQ *)
(* Prove that this function is always odd *)
(* in Propositional Form.  Use the Boolean Lemma above. *)
Theorem T80_91:forall n:nat, Nat.Odd(80*n+91).
Proof.
intros. 
apply Nat.odd_spec.
apply L80_91.
Qed.
