Require Import Omega.
(* Commment in COQ *)
(* Prove that this function is always odd *)
(* using boolean values.  This is decidable, as opposed to the *)
(* the proposition.   Hence, its easier. *)
Lemma L84_39:forall n:nat, Nat.odd(84*n+39)=true.
Proof.
intros. 
assert (HY84:Nat.even(84)=true).
{
	simpl.
	reflexivity.
}
assert (HY39:Nat.odd(39)=true).
{
	 unfold Nat.odd.
	simpl.
	reflexivity.
}
assert (HYN: Nat.even(84*n)=true).
{
	 rewrite Nat.even_mul.
	 rewrite HY84.
	 simpl. 
	 reflexivity.
}
assert (HYE84:Nat.Even(84*n)).
{
	apply Nat.even_spec.
	rewrite HYN;auto.
}
assert (HR:39+84*n = 84*n+ 39).
{
	 omega. 
}
rewrite <-HR.
rewrite Nat.odd_add_even.
rewrite HY39.
reflexivity.
apply HYE84.
Qed.
(* Commment in COQ *)
(* Prove that this function is always odd *)
(* in Propositional Form.  Use the Boolean Lemma above. *)
Theorem T84_39:forall n:nat, Nat.Odd(84*n+39).
Proof.
intros. 
apply Nat.odd_spec.
apply L84_39.
Qed.
