Require Import Omega.
(* Commment in COQ *)
(* Prove that this function is always odd *)
(* using boolean values.  This is decidable, as opposed to the *)
(* the proposition.   Hence, its easier. *)
Lemma L98_93:forall n:nat, Nat.odd(98*n+93)=true.
Proof.
intros. 
assert (HY98:Nat.even(98)=true).
{
	simpl.
	reflexivity.
}
assert (HY93:Nat.odd(93)=true).
{
	 unfold Nat.odd.
	simpl.
	reflexivity.
}
assert (HYN: Nat.even(98*n)=true).
{
	 rewrite Nat.even_mul.
	 rewrite HY98.
	 simpl. 
	 reflexivity.
}
assert (HYE98:Nat.Even(98*n)).
{
	apply Nat.even_spec.
	rewrite HYN;auto.
}
assert (HR:93+98*n = 98*n+ 93).
{
	 omega. 
}
rewrite <-HR.
rewrite Nat.odd_add_even.
rewrite HY93.
reflexivity.
apply HYE98.
Qed.
(* Commment in COQ *)
(* Prove that this function is always odd *)
(* in Propositional Form.  Use the Boolean Lemma above. *)
Theorem T98_93:forall n:nat, Nat.Odd(98*n+93).
Proof.
intros. 
apply Nat.odd_spec.
apply L98_93.
Qed.
